package inf1010.pusle.adventure;

/**
 * A small class giving additional attributes to certain items
 * that can now be equipped.
 */
class Equipment extends Item {

    /** Attack and defense bonuses given by this piece of equipment. */
    final int attackBonus, defenseBonus;
    /** The body part this piece of equipment is equipped on. */
    final BodyPart bp;

    /**
     * Creates a new piece of equipment.
     */
    public Equipment(String name, String desc,
		     int attackBonus, int defenseBonus, BodyPart bp) {
	super(name, desc);
	this.attackBonus = attackBonus;
	this.defenseBonus = defenseBonus;
	this.bp = bp;
    }
}

