package inf1010.pusle.adventure;

import java.util.Iterator;

/**
 * An implementation of a singly-linked list
 * that doesn't allow duplicated elements (technically a set).
 * If it is to comply to the 2nd mandatory assignment,
 * it must also be sorted.
 */
public class SinglyLinkedList<E extends Comparable<E>> implements Iterable<E> {

    // TODO
    // Add variables you'll need:
    // - Pointer to the first element
    // - (Optional) size
    // - Other possible vars you need for your implementation

    /**
     * Container class for list elements/nodes.
     * Declared private to prevent access outside this class.
     * 
     * @param <E> The class of objects the list can contain.
     */
    private class Element<E> {

	// TODO
	// Add variables you need:
	// - One E containing the data
	// - Pointer to the next Element

	/**
	 * Create a new list element.
	 * 
	 * @param element The object to be added to the list.
	 */
	public Element(E element) {
	    // TODO
	    // Set the data pointer
	}

	// TODO
	// Add any methods you need (possibly none)
    }

    /**
     * Adds the specified element to the collection.
     * Returns whether the collection changed or not. 
     *
     * @param e element to be added to this list.
     * @return true if the element was added, false if it was already there.
     * @throws NullPointerException if e is null.
     */
    public boolean add(E e) {
	// TODO
	// Add an element to the list if it's not already there.
	// Note that the 2nd mandatory assignment requires
	// that you add the elements alphabetically sorted
	return false;
    }

    /**
     * Gets the element similar to the given element.
     * Similar means the two elements return 0 upon compareTo.
     *
     * @param e The element to use as a key during look-up.
     * @return an element similar to e if it exists,
     *         or null if no such element exists.
     * @throws NullPointerException if e is null.
     */
    public E get(E e) {
	// TODO
	// Search the array for an element and return it
	// Hint: for-each and compareTo
	// Hint: String comparison with compareTo
	//       and alphabetical sorting
	return null;
    }

    /**
     * Returns true if this collection contains the specified element.
     * More specifically it returns true
     * if and only if the collection contains
     * at least one element c such that c != null
     * and c.compareTo(e) == 0. 
     *
     * @param e element whose presence in this collection is to be tested.
     * @return true if this collection contains the specified element. 
     */
    public boolean contains(E e) {
	// TODO
	// Find the element in the list and return true if it exists.
	// 
	// Hint: see get
	return false;
    }
	
    /**
     * Removes one occurrence of the specified element in this collection.
     * If this collection does not contain the element,
     * it is unchanged.
     *
     * @param e element to be removed from this collection, if present.
     * @return true if the element was removed from the list.
     * @throws NullPointerException if e is null.
     */
    public boolean remove(E e) {
	// TODO
	// Add code to remove an element if it exists
	// Hint: Iterator.remove()
	return false;
    }

    /**
     * Returns the number of elements in this collection.
     *
     * @return the number of elements in this collection.
     */
    public int size() {
	// TODO
	// Count the number of elements,
	// or if you buffered the size in a variable return it.
	return 0;
    }

    /**
     * Returns true if this collection contains no elements.
     *
     * @return true if his collection contains no elements.
     */
    public boolean isEmpty() {
	// TODO
	// Do a test to check if the list has any elements
	// Hint: size or first pointer
	return true;
    }

    /**
     * Clears the collection of elements.
     * After a call to this method,
     * no element should remain in the collection,
     * and its size should be equal to zero. 
     */
    public void clear() {
	// TODO
	// Clear the list
	// Hint: first pointer
    }

    /**
     * Returns an array containing all of the elements in this collection
     * in proper sequence (from first to last element);
     * the runtime type of the returned array is that of the specified array.
     * If the collection fits in the specified array with room to spare
     * (i.e., the array has more elements than the list),
     * the element in the array immediately following the end of the list
     * is set to null. (This is useful in determining the length of the list
     * only if the caller knows that the list does not contain
     * any null elements.) Suppose x is a list known to contain only strings.
     * The following code can be used to dump the list
     * into a newly allocated array of String:
     *
     * <pre>String[] y = x.toArray(new String[x.size()]);</pre>
     *
     * @param a the array into which the elements of the list
     *          are to be stored. 
     * @return An array containing all elements in the collection.
     * @throws NullPointerException if the specified array is null.
     */
    public E[] toArray(E[] a) {
	// TODO
	// Fill the array a with elements from the list.
	// If the array is larger than size(),
	// set the element a[size()] to null.
	// If the array isn't large enough,
	// create a generic array using the reflection API
	// or throw an Exception (notice that this method
	// can throw a NullPointerException)
	return a;
    }
	
    /**
     * Returns an iterator over a set of elements of type E
     *
     * @return an Iterator.
     */
    public Iterator<E> iterator() {
	// TODO
	// Create an iterator
	// This is a prime example of where to use an anonymous inner class
	// See http://download.oracle.com/javase/6/docs/api/java/util/Iterator.html
	return null;
    }
}
