package inf1010.pusle.adventure;

/**
 * A small class to represent objects in the adventure game:
 * Rooms, items, characters.
 */
abstract class Entity {

    /** A description of the entity. */
    protected String description;
	
    /**
     * Creates a new Entity,
     * used to force all sub-class instances to have a description.
     *
     * @param desc The description for this entity.
     */
    public Entity(String desc) {
	description = desc;
    }
	
    /**
     * Prints this entity's description to the shell.
     */
    public void printDescription() {
	System.out.println(description);
    }

}